local ffi = require 'ffi'
local lj_include = require 'lj_include'

ffi.cdef[[
typedef union sigval {
    int sival_int;
    void *sival_ptr;
} sigval_t;
typedef struct {
    int si_signo;
    int si_errno;
    int si_code;
    union {
	int _pad[((128 / sizeof(int)) - 3)];
	struct {
	    __pid_t si_pid;
	    __uid_t si_uid;
	} _kill;
	struct {
	    int si_tid;
	    int si_overrun;
	    sigval_t si_sigval;
	} _timer;
	struct {
	    __pid_t si_pid;
	    __uid_t si_uid;
	    sigval_t si_sigval;
	} _rt;
	struct {
	    __pid_t si_pid;
	    __uid_t si_uid;
	    int si_status;
	    __clock_t si_utime;
	    __clock_t si_stime;
	} _sigchld;
	struct {
	    void *si_addr;
	    short int si_addr_lsb;
	} _sigfault;
	struct {
	    long int si_band;
	    int si_fd;
	} _sigpoll;
	struct {
	    void *_call_addr;
	    int _syscall;
	    unsigned int _arch;
	} _sigsys;
    } _sifields;
} siginfo_t;
enum {
    SI_ASYNCNL = -60,
    SI_TKILL = -6,
    SI_SIGIO,
    SI_ASYNCIO,
    SI_MESGQ,
    SI_TIMER,
    SI_QUEUE,
    SI_USER,
    SI_KERNEL = 0x80
};
enum {
    ILL_ILLOPC = 1,
    ILL_ILLOPN,
    ILL_ILLADR,
    ILL_ILLTRP,
    ILL_PRVOPC,
    ILL_PRVREG,
    ILL_COPROC,
    ILL_BADSTK
};
enum {
    FPE_INTDIV = 1,
    FPE_INTOVF,
    FPE_FLTDIV,
    FPE_FLTOVF,
    FPE_FLTUND,
    FPE_FLTRES,
    FPE_FLTINV,
    FPE_FLTSUB
};
enum {
    SEGV_MAPERR = 1,
    SEGV_ACCERR
};
enum {
    BUS_ADRALN = 1,
    BUS_ADRERR,
    BUS_OBJERR,
    BUS_MCEERR_AR,
    BUS_MCEERR_AO
};
enum {
    TRAP_BRKPT = 1,
    TRAP_TRACE
};
enum {
    CLD_EXITED = 1,
    CLD_KILLED,
    CLD_DUMPED,
    CLD_TRAPPED,
    CLD_STOPPED,
    CLD_CONTINUED
};
enum {
    POLL_IN = 1,
    POLL_OUT,
    POLL_MSG,
    POLL_ERR,
    POLL_PRI,
    POLL_HUP
};
typedef union pthread_attr_t pthread_attr_t;
typedef struct sigevent {
    sigval_t sigev_value;
    int sigev_signo;
    int sigev_notify;
    union {
	int _pad[((64 / sizeof(int)) - 3)];
	__pid_t _tid;
	struct {
	    void (*_function) (sigval_t);
	    pthread_attr_t *_attribute;
	} _sigev_thread;
    } _sigev_un;
} sigevent_t;
enum {
    SIGEV_SIGNAL = 0,
    SIGEV_NONE,
    SIGEV_THREAD,
    SIGEV_THREAD_ID = 4
};
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

