local cjson = require 'cjson.safe'

-- Function used to get the platform information for ALL devices
local function get_platform_info(network)
    local platform_info = {}

    local rrs = network:QueryRR('*', 'TXT', 'platform_info: *', '*')
    if not rrs then return platform_info end
    for _, rr in ipairs(rrs) do
        local json = rr[3]:match('^platform_info: (.+)$')
        if json then
            platform_info[rr[1]] = cjson.decode(json)
        end
    end
    return platform_info
end

return get_platform_info
